#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_BuffCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_BuffCFG> Fish_BuffCFG::msSingleton(nullptr);

int Fish_BuffCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BuffCFGData* Fish_BuffCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_BuffCFGData>& Fish_BuffCFG::GetMapData()
{
	return mMapData;
}

void Fish_BuffCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_BuffCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BuffCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mBuffName = element->Attribute("BuffName");
		data.mBuffIcon = element->Attribute("BuffIcon");
		data.mBuffType = element->IntAttribute("BuffType");
		data.mDuration = element->IntAttribute("Duration");
		data.mNeedVIP = element->IntAttribute("NeedVIP");
		data.mBulletType = element->IntAttribute("BulletType");
		data.mBulletCount = element->IntAttribute("BulletCount");
		{
			const char* Param = element->Attribute("Param");
			std::vector<std::string> vecParam;
			boost::split(vecParam, Param, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecParam[i].c_str(), &temp))
				{
					data.mParam.push_back(temp);
				}
			}
		}
		data.mGuideImage = element->Attribute("GuideImage");
		data.mGuideInfo = element->Attribute("GuideInfo");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_BuffCFG::Load()
{
	Load("../Config/Fish_BuffCFG.xml");
}

Fish_BuffCFG* Fish_BuffCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BuffCFG());
	}
	return msSingleton.get();
}
